-- buff = { "victim", "skill", "amountRank" },
-- cast = { "source", "skill", "victim", "isBegin", "isPerform" },
-- create = { "source", "item" },
-- death = { "victim", "source", "skill", "isItem" },
-- debuff = { "victim", "skill", "amountRank" },
-- dispel = { "victim", "skill", "source", "sourceSkill", "isFailed" },
-- drain = { "source", "victim", "skill", "amount", "attribute" },
-- durability = { "source", "skill", "victim", "item" }, -- is not item then isAllItems = true
-- enchant = { "source", "victim", "skill", "item" },
-- environment = { "victim", "amount", "damageType" },
-- experience = { "amount", "source", "bonusAmount", "bonusType", "penaltyAmount", "penaltyType", "amountRaidPenalty", "amountGroupBonus", "victim" },
-- extraattack = { "victim", "skill", "amount" },
-- fade = { "victim", "skill" },
-- fail = { "source", "skill", "reason" },
-- feedpet = { "victim", "item" },
-- gain = { "source", "victim", "skill", "amount", "attribute" },
-- heal = { "source", "victim", "skill", "amount", "isCrit", "isDOT" },
-- hit = { "source", "victim", "skill", "amount", "element", "isCrit", "isDOT", "isSplit" },
-- honor = { "amount", "source", "sourceRank" }, -- if amount == false then isDishonor = true.
-- interrupt = { "source", "victim", "skill" },
-- leech = { "source", "victim", "skill", "amount", "attribute", "sourceGained", "amountGained", "attributeGained" },
-- miss = { "source", "victim", "skill", "missType" },
-- reputation = { "faction", "amount", "rank", "isNegative" },


local Parse={}
Relog.Parse=Parse

function Parse.Aura(info)
	if info.isBuff then
		Parse.AddLog("Buff", nil, nil, info.recipientName, info.recipientID, info.abilityName, nil, info.applications)
	else
		Parse.AddLog("Debuff", nil, nil, info.recipientName, info.recipientID, info.abilityName, nil, info.applications)
	end
end

function Parse.Cast(info)
	Parse.AddLog("Cast", info.sourceName, info.sourceID, info.recipientName, info.recipientID, info.abilityName, info.isBegin, info.isPerform)
end

function Parse.Create(info)
	if info.isCreated then
		Parse.AddLog("Item", info.sourceName, info.sourceID, nil, nil, nil, "Create", info.amount, "ItemLink", info.itemLink, "ItemName", info.itemName, "ItemRarity", info.itemRarity, "ItemString", info.itemString)
	else
		Parse.AddLog("Item", info.sourceName, info.sourceID, nil, nil, nil, "Loot", info.amount, "ItemLink", info.itemLink, "ItemName", info.itemName, "ItemRarity", info.itemRarity, "ItemString", info.itemString)
	end
end

function Parse.Damage(info)
	local Result="Hit"
	local Ability=info.abilityName

	if info.isCrit then
		Result="Crit"
	elseif info.isDoT then
		Result="Tick"
	elseif info.isGlancing then
		Result="Glancing"
	elseif info.isCrushing then
		Result="Crushing"
	elseif info.isSplit then
		Result="Split"	
	end

	if not Ability then
		Ability="melee"
	end

	Parse.AddLog("Damage", info.sourceName, info.sourceID, info.recipientName, info.recipientID, Ability, Result, info.amount, "DamageType", info.damageType, "AbsorbAmount", info.absorbAmount, "BlockAmount", info.blockAmount, "ResistAmount", info.resistAmount, "VulnerableAmount", info.vulnerableAmount)
end

function Parse.Death(info)
	local Ability=info.abilityName

	if info.sourceName and Ability==false then
		Ability="melee"
	end

	Parse.AddLog("Death", info.sourceName, info.sourceID, info.recipientName, info.recipientID, Ability, info.isItem)
end

function Parse.Dispel(info)
	Parse.AddLog("Dispel", info.sourceName, info.sourceID, info.recipientName, info.recipientID, info.sourceAbilityName, info.isItem, nil, "VictimAbility", info.recipientAbilityName)
end

--[[
Drain Logs
Attribute=Attribute Drained
]]
function Parse.Drain(info)
	Parse.AddLog("Drain", info.sourceName, info.sourceID, info.recipientName, info.recipientID, info.abilityName, nil, info.amount, "Attribute", info.attribute)
end

--[[
Durability
itemLink=Item damaged (need to either add to Parser-3.0 or here rarity etc info)
]]
function Parse.Durability(info)
	Parse.AddLog("Durability", info.sourceName, info.sourceID, info.recipientName, info.recipientID, info.abilityName, nil, nil, "ItemLink", info.item)
end


function Parse.Enchant(info)
	Parse.AddLog("Enchant", info.sourceName, info.sourceID, info.recipientName, info.recipientID, info.abilityName, nil, nil, "ItemLink", info.item)
end

function Parse.Environment(info)
	Parse.AddLog("Environment", nil, nil, info.recipientName, info.recipientID, info.abilityName, info.hazardType, info.amount, "DamageType", info.damageType, "AbsorbAmount", info.absorbAmount, "BlockAmount", info.blockAmount, "ResistAmount", info.resistAmount, "VulnerableAmount", info.vulnerableAmount)
end

function Parse.Experience(info)
	Parse.AddLog("Experience", info.sourceName, info.sourceID, info.recipientName, info.recipientID, nil, nil, info.amount, "BonusAmount", info.bonusAmount, "BonusType", info.bonusType, "PenaltyAmount", info.penaltyAmount, "PenaltyType", info.penaltyType, "AmountRaidPenalty", info.amountRaidPenalty,"AmountGroupBonus",info.amountGroupBonus)
end

function Parse.ExtraAttack(info)
	Parse.AddLog("Extra Attack", nil, nil, info.recipientName, info.recipientID, info.abilityName, nil, info.amount)
end

function Parse.Fade(info)
	Parse.AddLog("Fade", nil, nil, info.recipientName, info.recipientID, info.abilityName)
end

function Parse.Fail(info)
	Parse.AddLog("Fail", info.sourceName, info.sourceID, nil, nil, info.abilityName, info.reason)
end

function Parse.FeedPet(info)
	Parse.AddLog("Feed Pet", nil, nil, info.recipientName, info.recipientID, nil, nil, nil, "ItemLink", info.item)
end

function Parse.Gain(info)
	Parse.AddLog("Gain", info.sourceName, info.sourceID, info.recipientName, info.recipientID, info.abilityName, nil, info.amount, "Attribute", info.attribute)
end

function Parse.Heal(info)
	local Result="Heal"

	if info.isCrit then
		Result="Crit"
	elseif info.isDoT then
		Result="Tick"
	end

	Parse.AddLog("Heal", info.sourceName, info.sourceID, info.recipientName, info.recipientID, info.abilityName, Result, info.amount, "Overheal", info.overhealAmount)
end

function Parse.Honor(info)
	Parse.AddLog("Honor", info.sourceName, info.sourceID, UnitName("player"), "player", nil, nil, info.amount)
end

function Parse.Interrupt(info)
	Parse.AddLog("Interrupt", info.sourceName, info.sourceID, info.recipientName, info.recipientID, info.abilityName)
end

function Parse.Leech(info)
	Parse.AddLog("Leech", info.sourceName, info.sourceID, info.recipientName, info.recipientID, info.abilityName, nil, info.amount, "Attribute", info.attribute, "SourceGained", info.sourceGainedName, "AttributeGained", info.attributeGained, "AmountGained", info.amountGained)

	--Need to add info gathering on sourceGained
	if info.sourceGainedID then
		Relog.Units:UpdateUnit(info.sourceGainedID,Relog:GetTime())
	elseif info.sourceGainedName then
		Relog.Units:UpdateUnitByName(Source,Relog.db.char.Log.Time[num])
	end
end

function Parse.Miss(info)
	local Ability=info.abilityName

	if not Ability then
		Ability="melee"
	end

	Parse.AddLog("Miss", info.sourceName, info.sourceID, info.recipientName, info.recipientID, Ability, info.missType)
end

function Parse.Reputation(info)
	Parse.AddLog("Reputation", UnitName("player"), "player", nil, nil, info.abilityName, nil, info.amount, "Rank", info.rank, "Faction", info.faction)
end

function Parse.SetupParser()
	Relog:RegisterParserEvent({eventType = "Aura"}, Parse.Aura)
	Relog:RegisterParserEvent({eventType = "Cast"}, Parse.Cast)
	Relog:RegisterParserEvent({eventType = "Create"}, Parse.Create)
	Relog:RegisterParserEvent({eventType = "Damage"}, Parse.Damage)
	Relog:RegisterParserEvent({eventType = "Death"}, Parse.Death)
	Relog:RegisterParserEvent({eventType = "Dispel"}, Parse.Dispel)
	Relog:RegisterParserEvent({eventType = "Drain"}, Parse.Drain)
	Relog:RegisterParserEvent({eventType = "Durability"}, Parse.Durability)
	Relog:RegisterParserEvent({eventType = "Enchant"}, Parse.Enchant)
	Relog:RegisterParserEvent({eventType = "Environmental"}, Parse.Environment)
	Relog:RegisterParserEvent({eventType = "Experience"}, Parse.Experience)
	Relog:RegisterParserEvent({eventType = "Extra Attack"}, Parse.ExtraAttack)
	Relog:RegisterParserEvent({eventType = "Fade"}, Parse.Fade)
	Relog:RegisterParserEvent({eventType = "Fail"}, Parse.Fail)
	Relog:RegisterParserEvent({eventType = "Feed Pet"}, Parse.FeedPet)
	Relog:RegisterParserEvent({eventType = "Gain"}, Parse.Gain)
	Relog:RegisterParserEvent({eventType = "Heal"}, Parse.Heal)
	Relog:RegisterParserEvent({eventType = "Honor"}, Parse.Honor)
	Relog:RegisterParserEvent({eventType = "Interrupt"}, Parse.Interrupt)
	Relog:RegisterParserEvent({eventType = "Leech"}, Parse.Leech)
	Relog:RegisterParserEvent({eventType = "Miss"}, Parse.Miss)
end


--Still need to add functions and calls for processing the units
local Abbrev={
	Type=true,
	Source=true,
	Victim=true,
	Result=true,
	Ability=true,
	VictimAbility=true,
	DamageType=true,
	Attribute=true,
	ItemName=true,
	ItemString=true,
	BonusType=true,
	PenaltyType=true,
	SourceGained=true,
	AttributeGained=true,
	Faction=true,
	Rank=true,
}

function Parse.AddLog(Type, Source, SourceUnit, Victim, VictimUnit, Ability, Result, Amount, Extra1, Arg1, Extra2, Arg2, Extra3, Arg3, Extra4, Arg4, Extra5, Arg5, Extra6, Arg6)
	local num=Relog.db.char.NextLog
	local log=Relog.db.char.Log

	for k, v in pairs(log) do
		v[num]=nil
	end

	log.Time[num]=Relog:GetTime()
	log.Type[num]=Type
	log.Source[num]=Source
	log.Victim[num]=Victim
	log.Ability[num]=Ability
	log.Result[num]=Result
	log.Amount[num]=Amount

	if Extra1 then
		log[Extra1][num]=Arg1
	end

	if Extra2 then
		log[Extra2][num]=Arg2
	end

	if Extra3 then
		log[Extra3][num]=Arg3
	end

	if Extra4 then
		log[Extra4][num]=Arg4
	end

	if Extra5 then
		log[Extra5][num]=Arg5
	end

	if Extra6 then
		log[Extra6][num]=Arg6
	end


	--Abbreviate
	for k in pairs(Abbrev) do
		if log[k][num]~=nil then
			log[k][num]=Relog.Abbrev:GetAbbrev(log[k][num])
		end
	end



	Relog.db.char.LogSize=(Relog.db.char.LogSize+1)

	if Relog.db.char.LogSize>Relog.db.profile.MaxLogs then
		Relog.db.char.LogSize=Relog.db.profile.MaxLogs
		Relog.db.char.StartLog=Relog.db.char.StartLog+1
		if Relog.db.char.StartLog>Relog.db.profile.MaxLogs then
			Relog.db.char.StartLog=1
		end
		
		if log[Relog.db.char.StartLog] then
			Relog.Units:DeleteBeforeTime(log[Relog.db.char.StartLog].Time)
		end
	else
		local Pos=FauxScrollFrame_GetOffset(Relog.Window.ScrollBar)
		Relog.Window.SetPos(Pos+1)
	end

	Relog.db.char.NextLog=num+1

	if Relog.db.char.NextLog>Relog.db.profile.MaxLogs then
		Relog.db.char.NextLog=1
	end

	Parse.Part2(num)
end

function Parse.Part2(Num)
	local log=Relog.db.char.Log
	

	--Update Units
	if SourceUnit then
		Relog.Units:UpdateUnit(SourceUnit,log.Time[num])
	elseif Source then
		Relog.Units:UpdateUnitByName(Source,log.Time[num])
	end

	if VictimUnit then
		Relog.Units:UpdateUnit(VictimUnit,log.Time[num])
	elseif Victim then
		Relog.Units:UpdateUnitByName(Victim,log.Time[num])
	end


	Relog.Tags.CompileLog(num)
end

local LogEntry={}

function Relog:GetLog(num)
	for k, v in pairs(Relog.db.char.Log) do
		if v[num] and Abbrev[k] then
			LogEntry[k]=Relog.Abbrev:GetWord(v[num])
		else
			LogEntry[k]=v[num]
		end
	end
	return LogEntry
end